田忌赛马HDU

来源:互联网 发布:windows longhorn壁纸 编辑:程序博客网 时间:2024/05/16 00:28

Tian Ji – The Horse Racing HDU - 1052

题意

两千三百多年前,田忌采取孙膑的方法, 用上等马对齐威王的中等马,中等马对齐威王的下等马,下等马对齐威王的上等马赢得了比赛, 现在有多个等级的马匹, 并用数字量化每个马匹的等级, 求田忌最多能赢多少次

分析

贪心求解,叹为观止
/*
贪心策略:
1,如果田忌的最快马快于齐王的最快马,则两者比。
(因为若是田忌的别的马很可能就赢不了了,所以两者比)
2,如果田忌的最快马慢于齐王的最快马,则用田忌的最慢马和齐王的最快马比。
(由于所有的马都赢不了齐王的最快马,所以用损失最小的,拿最慢的和他比)
3,若相等,则比较田忌的最慢马和齐王的最慢马
3.1,若田忌最慢马快于齐王最慢马,两者比。
(田忌的最慢马既然能赢一个就赢呗,而且齐王的最慢马肯定也得有个和他比,所以选最小的比他快得。)
3.2,其他,则拿田忌的最慢马和齐王的最快马比。
(反正所有的马都比田忌的最慢马快了,所以这匹马肯定赢不了,选贡献最大的,干掉齐王的最快马)

大家想想就明白了应该。
*/
源地址http://poj.org/showmessage?message_id=164719

#include<iostream>#include<algorithm>#include<cstring>#include<cstdio>#include<cmath>#include<set>using namespace std;#define fo1(i,n) for(int i = 1; i <= n; ++i)#define fo0(i,n) for(int i = 0; i < n; ++i)#define me(a)   memset(a,0,sizeof(a))const int LEN = 1000;int tianji[LEN+3];int king[LEN+3];int main(void){    int n;    while(cin>>n&&n)    {        fo0(i,n)         cin>>tianji[i];        fo0(i,n)         cin>>king[i];         sort(tianji,tianji+n,greater<int>());         sort(king,king+n,greater<int>());         int a,b,c,d;         a=c=0;         b=d=n-1;         int res = 0;         while(c<=d)         {             if(tianji[a]>king[c])//如果田忌的最快马比国王的快,那就比             {                 ++res;                 ++a;                 ++c;             }             else if(tianji[a]<king[c])//如果田忌的最快马比国王的慢,那就用最慢                                       //的跟国王的最快的比             {                 --res;                 --b;                 ++c;             }             else//如果相等             {                 if(tianji[b]<king[d])//如果田忌的最慢的马比国王的最慢的马慢,                              //那就废物利用最大化,用最慢的跟国王最快的比                 {                     --res;                     --b;                     ++c;                 }                 else if(tianji[b]>king[d])//如果田忌的最慢的比国王的最慢的马                      //快,肯定有一个马要与国王的最慢的马比,那就选田忌的最慢的准没错                 {                     ++res;                     --d;                     --b;                 }                 else/*两者最慢的相等,就用田忌最慢的跟国王最快的比,因为相比于用最                 快的跟国王的最快的比打平局,这种方法剩下来的田忌最快的,                 以及国王的慢的,肯定是划算的*/                 {                     if(tianji[b] < king[c])                        --res;                     --b;                     ++c;                 }             }         }        cout<<200*res<<endl;    }    return 0;}

Tian Ji – The Horse Racing
Time Limit: 5000MS Memory Limit: 65536K
Total Submissions: 14788 Accepted: 4604

Description
Here is a famous story in Chinese history.

That was about 2300 years ago. General Tian Ji was a high official in the country Qi. He likes to play horse racing with the king and others.Both of Tian and the king have three horses in different classes, namely, regular, plus, and super. The rule is to have three rounds in a match; each of the horses must be used in one round. The winner of a single round takes two hundred silver dollars from the loser.Being the most powerful man in the country, the king has so nice horses that in each class his horse is better than Tian's. As a result, each time the king takes six hundred silver dollars from Tian.Tian Ji was not happy about that, until he met Sun Bin, one of the most famous generals in Chinese history. Using a little trick due to Sun, Tian Ji brought home two hundred silver dollars and such a grace in the next match.It was a rather simple trick. Using his regular class horse race against the super class from the king, they will certainly lose that round. But then his plus beat the king's regular, and his super beat the king's plus. What a simple trick. And how do you think of Tian Ji, the high ranked official in China?

Were Tian Ji lives in nowadays, he will certainly laugh at himself. Even more, were he sitting in the ACM contest right now, he may discover that the horse racing problem can be simply viewed as finding the maximum matching in a bipartite graph. Draw Tian’s horses on one side, and the king’s horses on the other. Whenever one of Tian’s horses can beat one from the king, we draw an edge between them, meaning we wish to establish this pair. Then, the problem of winning as many rounds as possible is just to find the maximum matching in this graph. If there are ties, the problem becomes more complicated, he needs to assign weights 0, 1, or -1 to all the possible edges, and find a maximum weighted perfect matching…

However, the horse racing problem is a very special case of bipartite matching. The graph is decided by the speed of the horses – a vertex of higher speed always beat a vertex of lower speed. In this case, the weighted bipartite matching algorithm is a too advanced tool to deal with the problem.

In this problem, you are asked to write a program to solve this special case of matching problem.

Input
The input consists of up to 50 test cases. Each case starts with a positive integer n ( n<=1000) on the first line, which is the number of horses on each side. The next n integers on the second line are the speeds of Tian’s horses. Then the next n integers on the third line are the speeds of the king’s horses. The input ends with a line that has a single `0’ after the last test case.

Output
For each input case, output a line containing a single number, which is the maximum money Tian Ji will get, in silver dollars.

Sample Input

3
92 83 71
95 87 74
2
20 20
20 20
2
20 19
22 18
0

Sample Output

200
0
0

原创粉丝点击